#!/usr/bin/perl
use strict;

my @PATH;
{
	chomp(my $path_str = `echo \$PATH`);
	foreach my $path_f (split(':',$path_str)) {
		if ($path_f eq '') {
			next;
		}

		if (substr($path_f,-1) ne '/') {
			$path_f .= '/';
		}

		push(@PATH,$path_f);
	}
}

if (-e 'program_checked') {
	system('rm -f program_checked');
}

my @all_model;
open(IN,'ls SVM_000??.model |');
while (<IN>) {
	chomp;
	if ($_ eq '') {
		next;
	}

	if (-e $_) {
		push(@all_model,$_);
	}
}
close(IN);

my $n = @all_model;

if ($n == 0) {
	die("No prediction model been selected!\n");
}

my @all_program = qw / bowtie-build bowtie RNAcofold Trinity svm-predict Rfam / ;

my %program_list;
open(IN,'<program_list');
while (<IN>) {
	chomp;
	if ($_ eq '') {
		next;
	}

	if ($_ =~ /\t/) {
		my $program = $`;
		my $location = $';

		$program =~ s/\s+//g;
		$location =~ s/\s+//g;

		$program_list{$program} = $location;
	}
	elsif ($_ =~ /=/) {
		my $program = $`;
		my $location = $';

		$program =~ s/\s+//g;
		$location =~ s/\s+//g;

		$program_list{$program} = $location;
	}
}
close(IN);

my $all_check = 1;
foreach my $program (@all_program) {
	if (!defined($program_list{$program}) || ($program_list{$program} eq '')) {
		if ($program eq 'RNAcofold') {
			$all_check = 0;
			print $program.' not exist!'."\n";
			next;
		}
		my $check = 0;
		foreach my $folder (@PATH) {
			if (-e $folder.$program) {
				$check = 1;
				last;
			}
		}
		if ($check == 0) {
			$all_check = 0;
			print $program.' not exist!'."\n";
		}
	}
	else {
		if (!(-e $program_list{$program})) {
			$all_check = 0;
			print $program.' not exist!'."\n";
		}
	}
}

if ($all_check == 1) {
	system('touch program_checked');
}
