#!/usr/bin/perl
use strict;

if (!(-e 'program_checked')) {
	print 'Please check the required programs and filled in the program_list with program location!'."\n";
	die;
}

open(LOG,'>Process_Log');
print LOG 'Step 1 start '.time()."\n";
my %allseq;
open(IN,'<'.$ARGV[0]);
chomp(my $first = <IN>);
if (substr($first,0,1) eq '>') {
	my $name = substr($first,1);
	my $seq = '';
	while (<IN>) {
		chomp;
		if ($_ eq '') {
			next;
		}

		if ($_ =~ /^>/) {
			if ($seq ne '') {
				$allseq{$seq} ++;
				$name = '';
				$seq = '';
			}
			$name = substr($_,1);
		}
		else {
			$seq .= $_;
		}
	}
	if ($seq ne '') {
		$allseq{$seq} ++;
	}
}
elsif (substr($first,0,1) eq '@') {
	my $name = substr($first,1);
	chomp(my $seq = <IN>);
	if ($seq ne '') {
		$allseq{$seq} ++;
	}
	<IN>;
	<IN>;
	$name = '';
	$seq = '';
	while (my $fir = <IN>) {
		chomp($fir);
		chomp(my $sec = <IN>);
		chomp(my $thr = <IN>);
		chomp(my $four = <IN>);

		$name = substr($fir,1);
		if ($sec =~ /\W/) {
			next;
		}

		$allseq{$sec} ++;
	}
}
elsif ($first =~ /\t/) {
	my @array = split("\t",$first);
	if ((@array > 2) || ($array[0] =~ /\D/) || ($array[1] =~ /\W/)) {
		print LOG 'Format not allowed!'.$/;
		close(LOG);
		die('Format not allowed!'.$/);
	}
	$allseq{$array[1]} += $array[0];
	while (<IN>) {
		chomp;
		if ($_ eq '') {
			next;
		}

		@array = split("\t",$_);

		if ((@array != 2) || ($array[0] =~ /\D/) || ($array[1] =~ /\W/)) {
			next;
		}

		$allseq{$array[1]} += $array[0];
	}
}
else {
	print LOG 'Format not allowed!'.$/;
	close(LOG);
	die('Format not allowed!'.$/);
}

print LOG 'Step 1: Input '.$ARGV[0]." done!\n";

if (!(-e 'SeqMerge')) {
	mkdir('SeqMerge');
}
elsif (!(-d 'SeqMerge')) {
	system('rm -f SeqMerge');
	mkdir('SeqMerge');
}
chdir('SeqMerge');

print LOG 'Step 1: Change working directory to SeqMerge!'."\n";

open(FA,'>seq_merge.fa');
open(OUT,'>seq_merge.txt');
my $id = 1;
my $length = (keys %allseq);
$length = length($length);

foreach my $seq (sort{$a cmp $b} (keys %allseq)) {
	print FA sprintf(">tmp%0".$length."d",$id)."\n".$seq."\n";
	print OUT join("\t",sprintf("tmp%0".$length."d",$id),$allseq{$seq},$seq)."\n";
	$id ++;
}

close(OUT);
close(FA);

print LOG 'Step 1: Create file seq_merge.fa and seq_merge.txt'."\n";

chdir('../');

print LOG 'Step 1 done '.time()."\n";
close(LOG);
