#!/usr/bin/perl
use strict;

if (!(-e './SeqMerge/seq_merge.txt') || !(-e './SeqMerge/seq_merge.fa')) {
	die('complete step1 first');
}

my $Rfam = '';
#my $Rfam = '/home/jsyf/useful_file/Rfam/Rfam_clean.fa';
#my $Rfam = '/home/u00wcc02/u00wcc02/jsyf_use/training_ref_rice/useful_file/Rfam_clean.fa';
open(IN,'<program_list');
while (<IN>) {
	chomp;
	if ($_ eq '') {
		next;
	}

	my ($program,$location) = split(/[\t=]/,$_);

	$program =~ s/\s+//g;
	$location =~ s/\s+//g;

	if ($program eq 'Rfam') {
		$Rfam = $location;
	}
}
close(IN);

if (($Rfam eq '') || !(-e $Rfam)) {
	die("Rfam file not exist!\nPlease edit program_list!\n");
}

if (!(-e 'RemoveRfam')) {
	mkdir('RemoveRfam');
}
elsif ((!(-d 'RemoveRfam'))) {
	system('rm -f RemoveRfam');
	mkdir('RemoveRfam');
}
chdir('RemoveRfam');

system('echo "Step 2 start! '.time().'" >> ../Process_Log');

system('cp -s '.$Rfam.' ./Rfam.fa');
system('cp -s ../SeqMerge/seq_merge.txt ../SeqMerge/seq_merge.fa ./');
system('bowtie-build -f Rfam.fa Rfam');
system('bowtie -f -a -v 0 Rfam seq_merge.fa read_Rfam');

system('echo "Step 2: Mapping Rfam done!" >> ../Process_Log');

my %rfam_pos;
open(BOWTIE,'<read_Rfam');
while (<BOWTIE>) {
	chomp;
	if ($_ eq '') {
		next;
	}

	my ($id) = split("\t",$_);

	$rfam_pos{$id} = 1;
}
close(BOWTIE);

system('echo "Step 2: mapping result loaded." >> ../Process_Log');

my %allseq;
open(LIST,'<seq_merge.txt');
while (<LIST>) {
	chomp;
	if ($_ eq '') {
		next;
	}

	my ($id,$count,$seq) = split("\t",$_);

	if ($rfam_pos{$id}) {
		next;
	}

	$allseq{$seq} += $count;
}
close(LIST);

open(OUT,'>allseq.fa');
my $id = 1;
my $length = (keys %allseq);
$length = length($length);

foreach my $seq (sort{$a cmp $b} (keys %allseq)) {
	print OUT sprintf(">allseq%0".$length."d_rich%d",$id,$allseq{$seq})."\n".$seq."\n";
	$id ++;
}

close(OUT);

system('echo "Step 2: Structure RNA filtered!" >> ../Process_Log');

chdir('../');

system('cp -s ./RemoveRfam/allseq.fa ./');
system('echo "Step 2 done! '.time().'" >> Process_Log');
