#!/usr/bin/perl
use strict;

if (!(-e './RemoveRfam/allseq.fa')) {
	die('Complete step 2 first!');
}
if (!(-e './Trinity/bowtie/full_seq')) {
	die('Complete step 3 first!');
}

if (!(-e 'Pair')) {
	mkdir('Pair');
}
elsif ((!(-d 'Pair'))) {
	system('rm -f Pair');
	mkdir('Pair');
}
chdir('Pair');

system('echo "Step 4 start! '.time().'" >> ../Process_Log');

my $n_paseq = 0;
my $n_pagroup = 1;

my %allseq;
my %allseq_group;
open(IN,'<../RemoveRfam/allseq.fa');
while (my $name = <IN>) {
	chomp($name);
	$name = substr($name,1);
	chomp(my $seq = <IN>);

	my ($count) = $name =~ /allseq\d+_rich(\d+)/;
	my $len = length($seq);

	if (($len < 18) || ($len > 25)) {
		next;
	}

	$n_paseq ++;

	$allseq{$name} = $seq;
	$allseq_group{'passenger'}{$n_pagroup}{$name} = 1;

	if ($n_paseq == 10000) {
		$n_pagroup ++;
		$n_paseq = 0;
	}

	if (($len >= 20) && ($len <= 24) && ($count >= 10)) {
		$allseq_group{'guide'}{$name} = 1;
	}
}
close(IN);

system('echo "Step 4: Read sequence file done!" >> ../Process_Log');

open(OUT,'>Cofold_use_guide.fa');
foreach my $name (sort{$a cmp $b} (keys %{$allseq_group{'guide'}})) {
	print OUT '>'.$name."\n".$allseq{$name}."\n";
}
close(OUT);

system('echo "Step 4: Guide sequence output done!" >> ../Process_Log');

my @all_group = (keys %{$allseq_group{'passenger'}});

for (my $i=0;$i<@all_group;$i+=10) {
	for (my $j=0;$j<10;$j++) {
		my $k = $i+$j;
		if (!defined($all_group[$k])) {
			next;
		}

		if (fork() == 0) {
			my $group = $all_group[$k];

			open(OUT,'>Cofold_use_passenger_'.sprintf("%03d",$group).'.fa');
			foreach my $name (sort{$a cmp $b} (keys %{$allseq_group{'passenger'}{$group}})) {
				print OUT '>'.$name."\n".$allseq{$name}."\n";
			}
			close(OUT);

			print 'Group: '.$group.' done!'."\n";

			exit;
		}
	}

	wait for 0 .. 10;
}

system('echo "Step 4.1 done!" >> ../Process_Log');


chdir('../');
