#!/usr/bin/perl
use strict;

sub uniq {
	my %seen;
	map $seen{$_}=1,@_;
	my @uniq = sort{$a cmp $b} (keys %seen);
	return(@uniq);
}

my %name_full;
my %full_name;
open(IN,'<../full_seq');
while (<IN>) {
	chomp;
	if ($_ eq '') {
		next;
	}

	my @array = split("\t",$_);

	my $ll = length($array[1]);
	my $lr = length($array[3]);

	push(@{$name_full{$array[0]}},[$array[1].$array[2].$array[3],$ll,$lr]);

	my $count = @{$name_full{$array[0]}};
	$count = $count - 1;

	push(@{$full_name{$array[1].$array[2].$array[3]}},$array[0].'_'.$count.$ll.$lr);
}
close(IN);

my $n_pass = 0;
open(IN,'ls Cofold_use_passenger_*.fa | ');
while (<IN>) {
	chomp;
	if ($_ eq '') {
		next;
	}

	if (-e $_) {
		$n_pass ++;
	}
}
close(IN);

for (my $i=0;$i<=$n_pass;$i+=10) {
	for (my $j=0;$j<10;$j++) {
		my $n = $i+$j;
		if ($n == 0) {
			next;
		}
		elsif (!(-e sprintf("Cofold_use_passenger_%03d.fa",$n)) || !(-e sprintf("./working_%03d/Cofold_filtered_read_%03d.txt",$n,$n)) ||!(-e sprintf("./working_%03d/Cofold_filtered_full_%03d.txt",$n,$n))) {
			next;
		}

		if (fork() == 0) {
			chdir(sprintf("./working_%03d",$n));

			my %valid_name;
			my %read_name;
			open(IN,'<../Cofold_use_guide.fa');
			while (my $name = <IN>) {
				chomp($name);
				chomp(my $seq = <IN>);

				$name = substr($name,1);

				if (defined($read_name{$seq}) && ($read_name{$seq} ne $name)) {
					print "multi-name:$seq\n";
					next;
				}

				$read_name{$seq} = $name;
				$valid_name{$name} = 1;
			}
			close(IN);

			open(IN,'<'.sprintf("../Cofold_use_passenger_%03d.fa",$n));
			while (my $name = <IN>) {
				chomp($name);
				chomp(my $seq = <IN>);

				$name = substr($name,1);

				if (defined($read_name{$seq}) && ($read_name{$seq} ne $name)) {
					print "multi-name:$seq\n";
					next;
				}

				$read_name{$seq} = $name;
				$valid_name{$name} = 1;
			}
			close(IN);

			foreach my $seq_type ('read','full') {
				if (fork() == 0) {
					open(OUT,'>'.sprintf("Cofold_filtered_%s_%03d_name.txt",$seq_type,$n));
					open(IN,'<'.sprintf("Cofold_filtered_%s_%03d.txt",$seq_type,$n));
					while (<IN>) {
						chomp;
						if ($_ eq '') {
							next;
						}

						my @array = split("\t",$_);
						if (@array != 5) {
							next;
						}

						my $seq_q = $array[0];
						my $seq_s = $array[1];

						if ($seq_type eq 'read') {
							if (!defined($read_name{$seq_q}) || !defined($read_name{$seq_s})) {
								print "no read name!\n";
								next;
							}
							print OUT join("\t",$read_name{$seq_q},$read_name{$seq_s},@array)."\n";
						}
						elsif ($seq_type eq 'full') {
							my @name_q;
							my @name_s;

							if (defined($full_name{$seq_q}) && (@{$full_name{$seq_q}} > 0)) {
								#push(@name_q,@{$full_name{$seq_q}});

								foreach my $qq (@{$full_name{$seq_q}}) {
									my $qqq = $qq;
									$qqq =~ s/_\d{3}$//;

									if ($valid_name{$qqq} == 1) {
										push(@name_q,$qq);
									}
								}
							}
							if (defined($read_name{$seq_q}) && ($read_name{$seq_q} ne '')) {
								if (!defined($name_full{$read_name{$seq_q}}) || (@{$name_full{$read_name{$seq_q}}} == 0)) {
									push(@name_q,$read_name{$seq_q}.'_000');
								}
							}

							if (defined($full_name{$seq_s}) && (@{$full_name{$seq_s}} > 0)) {
								#push(@name_s,@{$full_name{$seq_s}});

								foreach my $ss (@{$full_name{$seq_s}}) {
									my $sss = $ss;
									$sss =~ s/_\d{3}$//;

									if ($valid_name{$sss} == 1) {
										push(@name_s,$ss);
									}
								}
							}
							if (defined($read_name{$seq_s}) && ($read_name{$seq_s} ne '')) {
								if (!defined($name_full{$read_name{$seq_s}}) || (@{$name_full{$read_name{$seq_s}}} == 0)) {
									push(@name_s,$read_name{$seq_s}.'_000');
								}
							}

							@name_q = &uniq(@name_q);
							@name_s = &uniq(@name_s);
							foreach my $qq (@name_q) {
								foreach my $ss (@name_s) {
									print OUT join("\t",$qq,$ss,@array)."\n";
								}
							}
						}
					}
					close(IN);
					close(OUT);

					exit;
				}
			}

			chdir('../');

			wait for 0 .. 2;
			exit;
		}
	}

	wait for 0 .. 10;
}
