#!/usr/bin/perl
use strict;

my $n_pass = 0;
open(IN,'ls Cofold_use_passenger_*.fa | ');
while (<IN>) {
	chomp;
	if ($_ eq '') {
		next;
	}

	if (-e $_) {
		$n_pass ++;
	}
}
close(IN);

my @feature_subgroup;
push(@feature_subgroup,[0,0,0,1,0]);
push(@feature_subgroup,[0,0,0,0,1]);
push(@feature_subgroup,[0,0,0,1,1]);

for (my $i=0;$i<=$n_pass;$i+=20) {
	for (my $j=0;$j<20;$j++) {
		my $n = $i + $j;

		my $file_read = sprintf("./working_%03d/Cofold_filtered_read_%03d_name.txt",$n,$n);
		my $file_full = sprintf("./working_%03d/Cofold_filtered_full_%03d_name.txt",$n,$n);

		if ($n == 0) {
			next;
		}
		elsif (!(-e $file_read) || !(-e $file_full)) {
			next;
		}

		if (fork() == 0) {
			my %result_read;
			open(IN,'<'.$file_read);
			while (<IN>) {
				chomp;
				if ($_ eq '') {
					next;
				}

				my @array = split("\t",$_);

				my $name_q = shift(@array);
				my $name_s = shift(@array);

				if (defined($result_read{$name_q}{$name_s}) && (@{$result_read{$name_q}{$name_s}} == 5)) {
					print "multi-read!\n";
					next;
				}
				$result_read{$name_q}{$name_s} = \@array;
			}
			close(IN);

			open(IN,'<'.$file_full);
			while (<IN>) {
				chomp;
				if ($_ eq '') {
					next;
				}

				my @array = split("\t",$_);

				my $name_q = shift(@array);
				my $name_s = shift(@array);

				my $allseq_q = $name_q;
				my $allseq_s = $name_s;
				$allseq_q =~ s/_\d{3}$//;
				$allseq_s =~ s/_\d{3}$//;

				if (!defined($result_read{$allseq_q}{$allseq_s}) || (@{$result_read{$allseq_q}{$allseq_s}} == 0)) {
					next;
				}

				#feature: first base
				my $first_val = 0;
				if ((substr($result_read{$allseq_q}{$allseq_s}[0],0,1) eq 'T') || (substr($result_read{$allseq_q}{$allseq_s}[0],0,1) eq 'U')) {
					$first_val = 1;
				}

				#feature: read count
				my @count_array;
				if ($allseq_q =~ /allseq\d+_rich(\d+)/) {
					$count_array[0] = $1;
				}
				if ($allseq_s =~ /allseq\d+_rich(\d+)/) {
					$count_array[1] = $1;
				}

				@count_array = sort{$a <=> $b} @count_array;

				my $count_val = $count_array[1] / $count_array[0];

				undef(@count_array);

				#feature: free energy
				my $energy_val = $array[4];
				if ($energy_val < 0) {
					$energy_val = 0 - $energy_val;
				}

				#feature: cutting site
				my %cutting_str;#not value
				my @len;
				$len[0] = length($result_read{$allseq_q}{$allseq_s}[0]);
				$len[1] = length($result_read{$allseq_q}{$allseq_s}[1]);

				my @full_len;
				$full_len[0] = length($array[0]);
				$full_len[1] = length($array[1]);

				my @index;
				if ($name_q =~ /allseq\d+_rich\d+_\d(\d)\d/) {
					$index[0] = $1;
				}
				if ($name_s =~ /allseq\d+_rich\d+_\d(\d)\d/) {
					$index[1] = $1;
				}

				my @pair_structure;#former base, former pattern, later pattern, later base
				$pair_structure[0] = [split('',reverse($array[0]))];
				$pair_structure[1] = [split('',reverse($array[2]))];
				$pair_structure[2] = [split('',$array[3])];
				$pair_structure[3] = [split('',$array[1])];

				my @position_array;
				foreach (0..1) {
					$position_array[$_] = [];
					$position_array[$_][0] = $index[$_] + 1;
					$position_array[$_][1] = $index[$_] + 11;
					$position_array[$_][2] = $index[$_] + $len[$_];
				}

				my $pattern_string = '';
				my %pattern_state;

				my %output_pattern;

				my @this_pos;
				$this_pos[0] = $full_len[0];
				$this_pos[1] = 1;

				my @this_compare = ['','','','']; #former base, former pattern, later pattern, later base;
				foreach my $i (0,1,2,3) {
					$this_compare[$i] = shift(@{$pair_structure[$i]});
				}

				while (($this_compare[0] ne '') && ($this_compare[3] ne '')) {
					my $this = '';
					if ($this_compare[1] eq '(') {
						if ($this_compare[2] eq ')') {
							$this = 'M';

							foreach my $i (0,1,2,3) {
								$this_compare[$i] = shift(@{$pair_structure[$i]});
							}
							$this_pos[0] --;
							$this_pos[1] ++;
						}
						else {
							$this = 'I';

							foreach my $i (2,3) {
								$this_compare[$i] = shift(@{$pair_structure[$i]});
							}
							$this_pos[1] ++;
						}
					}
					elsif ($this_compare[1] eq '.') {
						if ($this_compare[2] eq ')') {
							$this = 'D';

							foreach my $i (0,1) {
								$this_compare[$i] = shift(@{$pair_structure[$i]});
							}
							$this_pos[0] --;
						}
						elsif ($this_compare[2] eq '.') {
							$this = 'm';

							foreach my $i (0,1,2,3) {
								$this_compare[$i] = shift(@{$pair_structure[$i]});
							}
							$this_pos[0] --;
							$this_pos[1] ++;
						}
						else {
							$this = 'D';

							foreach my $i (0,1,2,3) {
								$this_compare[$i] = shift(@{$pair_structure[$i]});
							}
							$this_pos[0] --;
							$this_pos[1] ++;
						}
					}
					else {
						$this = 'I';

						foreach my $i (0,1,2,3) {
							$this_compare[$i] = shift(@{$pair_structure[$i]});
						}
						$this_pos[0] --;
						$this_pos[1] ++;
					}

					$pattern_string = $this.$pattern_string;

					if ($this_pos[0] == $position_array[0][0]) {
						$pattern_state{'start'} = 6;
						$output_pattern{'start'} = substr($pattern_string,0,4);
					}
					elsif ($pattern_state{'start'} > 0) {
						$pattern_state{'start'} --;
						$output_pattern{'start'} = substr($pattern_string,0,1).$output_pattern{'start'};
					}

					if ($this_pos[0] == $position_array[0][1]) {
						$pattern_state{'mid'} = 6;
						$output_pattern{'mid'} = substr($pattern_string,0,4);
					}
					elsif ($pattern_state{'mid'} > 0) {
						$pattern_state{'mid'} --;
						$output_pattern{'mid'} = substr($pattern_string,0,1).$output_pattern{'mid'};
					}

					if ($this_pos[0] == $position_array[0][2]) {
						$pattern_state{'end'} = 5;
						$output_pattern{'end'} = substr($pattern_string,0,5);
					}
					elsif (($this_pos[0] < $position_array[0][2]) && (!$output_pattern{'end'})) {
						$pattern_state{'end'} = 4;
						$output_pattern{'end'} = substr($pattern_string,0,6);
					}
					elsif ($pattern_state{'end'} > 0) {
						$pattern_state{'end'} --;
						$output_pattern{'end'} = substr($pattern_string,0,1).$output_pattern{'end'};
					}

					if ($this_compare[0] eq '') {
						$this_compare[0] = '-';
					}
					elsif ($this_compare[3] eq '') {
						$this_compare[3] = '-';
					}
				}

				%cutting_str = %output_pattern;

				my %cutting_val;
				{
					my %this_str;
					$this_str{'start'} = sprintf("%10s",$cutting_str{'start'});
					$this_str{'start'} =~ s/ /0/g;
					$this_str{'mid'} = $cutting_str{'mid'};
					$this_str{'end'} = sprintf("%-10s",$cutting_str{'end'});
					$this_str{'end'} =~ s/ /0/g;

					my @type_order = ('M','m','I','D','0');

					foreach my $matrix ('start','mid','end') {
						for (my $i=0;$i<length($this_str{$matrix});$i++) {
							foreach my $matrix_content (@type_order) {
								if (substr($this_str{$matrix},$i,1) eq $matrix_content) {
										push(@{$cutting_val{$matrix}},1);
								}
								else {
									push(@{$cutting_val{$matrix}},0);
								}
							}
						}
					}
				}

				#feature: triplet element
				my @triplet_val;
				my %this_triplet;
				for (my $i=0;$i<2;$i++) {
					my $this_seq = $array[$i];
					my $this_pat = $array[($i+2)];
					$this_pat =~ s/\)/\(/g;
					$this_pat =~ /^\.*([\(\.]*\()\.*$/;

					my $start = index($this_pat,$1);
					my $end = index($this_pat,$1) + length($1) - 1;

					for (my $j=$start;$j<=$end;$j++) {
						my $triplet_base = substr($this_seq,$j,1);
						my $triplet_pattern;
						if ($j == 0) {
							$triplet_pattern = '.'.substr($this_pat,$j,2);
						}
						else {
							$triplet_pattern = substr($this_pat,($j-1),3);
						}

						if ($j == (length($this_seq) - 1)) {
							$triplet_pattern .= '.';
						}

						$this_triplet{$triplet_base.$triplet_pattern} ++;
						$this_triplet{'All'} ++;
					}
				}

				foreach my $base ('A','T','C','G') {
					foreach my $a ('(','.') {
						foreach my $b ('(','.') {
							foreach my $c ('(','.') {
								$this_triplet{$base.$a.$b.$c} += 0;
								my $val = $this_triplet{$base.$a.$b.$c};
								$val = $val / $this_triplet{'All'};
								$val = sprintf("%6.4f",$val);

								push(@triplet_val,$val);
							}
						}
					}
				}

				my @all_feature;
				@{$all_feature[0]} = ($first_val);
				@{$all_feature[1]} = ($count_val);
				@{$all_feature[2]} = ($energy_val);
				@{$all_feature[3]} = @triplet_val;
				@{$all_feature[4]} = (@{$cutting_val{'start'}},@{$cutting_val{'mid'}},@{$cutting_val{'end'}});

				foreach my $row (@feature_subgroup) {
					my @output_array;

					push(@output_array,'+1');

					for (my $i=0;$i<@all_feature;$i++) {
						if ($row->[$i] == 1) {
							push(@output_array,@{$all_feature[$i]});
						}
					}

					open(OUT,'>>Score_'.join('',@{$row}).'_'.sprintf("%03d",$n).'.txt');
					print OUT $output_array[0];
					for (my $i=1;$i<@output_array;$i++) {
						print OUT ' '.$i.':'.$output_array[$i];
					}
					print OUT "\n";
					close(OUT);

					open(OUT,'>>Seq_'.join('',@{$row}).'_'.sprintf("%03d",$n).'.txt');
					print OUT join("\t",$allseq_q,$allseq_s,@{$result_read{$allseq_q}{$allseq_s}}[0,1])."\n";
					close(OUT);
				}

			}
			close(IN);

			exit;
		}
	}

	wait for 0 .. 20;
}
