#!/usr/bin/perl
use strict;

my $predict = '';
open(IN,'<program_list');
while (<IN>) {
	chomp;
	if ($_ eq '') {
		next;
	}

	my ($program,$path) = split(/[\t=]/,$_);

	$program =~ s/\s+//g;
	$path =~ s/\s+//g;

	if ($program eq 'svm-predict') {
		$predict = $path;
	}
}
close(IN);

if ($predict eq '') {
	die('No svm-predict program in program_list!');
}

my @command;
open(IN,'ls ./Pair/Score_?????.txt | ');
while (<IN>) {
	chomp;
	if ($_ eq '') {
		next;
	}

	my $group;
	if ($_ =~ /^\.\/Pair\/Score_(\d{5}).txt$/) {
		$group = $1;
	}
	else {
		next;
	}

	my $file_model = './SVM_'.$group.'.model';
	my $file_score = './Pair/Score_'.$group.'.txt';
	my $file_info = './Pair/Seq_'.$group.'.txt';

	my $file_testing_output = 'SVM_testing_'.$group.'.out';

	if ((-e $file_model) && (-e $file_score)) {
		push(@command,[$group,$file_model,$file_score,$file_testing_output,$file_info]);
	}
}
close(IN);

my $n = @command;

foreach my $row (@command) {
	my ($group,$model_file,$testing_file,$output_file,$file_info) = @{$row};

	if (fork() == 0) {
		system($predict.' -b 1 '.$testing_file.' '.$model_file.' '.$output_file);

		open(OUT,'>miRNA_duplex');
		open(TEST,'<'.$output_file);
		open(INFO,'<'.$file_info);
		<TEST>;
		while (my $test = <TEST>) {
			chomp($test);
			chomp(my $info = <INFO>);

			my @info_a = split("\t",$info);
			my ($test_result,$test_result_score) = split(/\s+/,$test);

			if ($test_result == 1) {
				print OUT join("\t",$info_a[2],$info_a[3],$test_result_score)."\n";
			}
		}
		close(TEST);
		close(INFO);
		close(OUT);

		exit;
	}
}

wait for 0 .. $n;

